Index: /branches/version-2_11-dev/data/module/SOAP/Type/duration.php
===================================================================
--- /branches/version-2_11-dev/data/module/SOAP/Type/duration.php	(revision 21318)
+++ /branches/version-2_11-dev/data/module/SOAP/Type/duration.php	(revision 21410)
@@ -1,96 +1,71 @@
 <?php
-/**
- * This file contains the code for the SOAP_Type_duration class.
- *
- * PHP versions 4 and 5
- *
- * LICENSE: This source file is subject to version 2.02 of the PHP license,
- * that is bundled with this package in the file LICENSE, and is available at
- * through the world-wide-web at http://www.php.net/license/2_02.txt.  If you
- * did not receive a copy of the PHP license and are unable to obtain it
- * through the world-wide-web, please send a note to license@php.net so we can
- * mail you a copy immediately.
- *
- * @category   Web Services
- * @package    SOAP
- * @author     Shane Caraveo <Shane@Caraveo.com>   Port to PEAR and more
- * @author     Jan Schneider <jan@horde.org>       Maintenance
- * @copyright  2003-2007 The PHP Group
- * @license    http://www.php.net/license/2_02.txt  PHP License 2.02
- * @link       http://pear.php.net/package/SOAP
- */
+/*
+http://www.w3.org/TR/xmlschema-2/
 
-/**
- * This is only an aproximation of duration, more work still to do.  See the
- * schema url for more info on duration.
- *
- * http://www.w3.org/TR/xmlschema-2/
- *
- * [Definition:]   duration represents a duration of time. The value space of
- * duration is a six-dimensional space where the coordinates designate the
- * Gregorian year, month, day, hour, minute, and second components
- * defined in  5.5.3.2 of [ISO 8601], respectively. These components are
- * ordered in their significance by their order of appearance i.e. as year,
- * month, day, hour, minute, and second.
- *
- * 3.2.6.1 Lexical representation
- * The lexical representation for duration is the [ISO 8601] extended
- * format PnYn MnDTnH nMnS, where nY represents the number of
- * years, nM the number of months, nD the number of days, 'T' is the
- * date/time separator, nH the number of hours, nM the number of
- * minutes and nS the number of seconds. The number of seconds
- * can include decimal digits to arbitrary precision.
- *
- * The values of the Year, Month, Day, Hour and Minutes components
- * are not restricted but allow an arbitrary integer. Similarly, the
- * value of the Seconds component allows an arbitrary decimal.
- * Thus, the lexical representation of duration does not follow the
- * alternative format of  5.5.3.2.1 of [ISO 8601].
- *
- * An optional preceding minus sign ('-') is allowed, to indicate a
- * negative duration. If the sign is omitted a positive duration is
- * indicated. See also ISO 8601 Date and Time Formats (D).
- *
- * For example, to indicate a duration of 1 year, 2 months, 3 days,
- * 10 hours, and 30 minutes, one would write: P1Y2M3DT10H30M.
- * One could also indicate a duration of minus 120 days as: -P120D.
- *
- * Reduced precision and truncated representations of this format
- * are allowed provided they conform to the following:
- *
- * If the number of years, months, days, hours, minutes, or seconds
- * in any expression equals zero, the number and its corresponding
- * designator *may* be omitted. However, at least one number and
- * its designator *must* be present.
- * The seconds part *may* have a decimal fraction.
- * The designator 'T' shall be absent if all of the time items are absent.
- * The designator 'P' must always be present.
- * For example, P1347Y, P1347M and P1Y2MT2H are all allowed; P0Y1347M
- * and P0Y1347M0D are allowed. P-1347M is not allowed although -P1347M
- * is allowed. P1Y2MT is not allowed.
- *
- * @access   public
- * @package  SOAP
- * @author   Shane Caraveo <shane@php.net> Port to PEAR and more
- * @author   Jan Schneider <jan@horde.org> Maintenance
- * @todo     Figure out best aproximation for year and month conversion to
- *           seconds
- */
+[Definition:]   duration represents a duration of time. The value space of
+duration is a six-dimensional space where the coordinates designate the
+Gregorian year, month, day, hour, minute, and second components
+defined in  5.5.3.2 of [ISO 8601], respectively. These components are
+ordered in their significance by their order of appearance i.e. as year,
+month, day, hour, minute, and second. 
+
+3.2.6.1 Lexical representation
+The lexical representation for duration is the [ISO 8601] extended
+format PnYn MnDTnH nMnS, where nY represents the number of
+years, nM the number of months, nD the number of days, 'T' is the
+date/time separator, nH the number of hours, nM the number of
+minutes and nS the number of seconds. The number of seconds
+can include decimal digits to arbitrary precision.
+
+The values of the Year, Month, Day, Hour and Minutes components
+are not restricted but allow an arbitrary integer. Similarly, the
+value of the Seconds component allows an arbitrary decimal.
+Thus, the lexical representation of duration does not follow the
+alternative format of  5.5.3.2.1 of [ISO 8601].
+
+An optional preceding minus sign ('-') is allowed, to indicate a
+negative duration. If the sign is omitted a positive duration is
+indicated. See also ISO 8601 Date and Time Formats (D). 
+
+For example, to indicate a duration of 1 year, 2 months, 3 days,
+10 hours, and 30 minutes, one would write: P1Y2M3DT10H30M.
+One could also indicate a duration of minus 120 days as: -P120D. 
+
+Reduced precision and truncated representations of this format
+are allowed provided they conform to the following: 
+
+If the number of years, months, days, hours, minutes, or seconds
+in any expression equals zero, the number and its corresponding
+designator *may* be omitted. However, at least one number and
+its designator *must* be present. 
+The seconds part *may* have a decimal fraction. 
+The designator 'T' shall be absent if all of the time items are absent.
+The designator 'P' must always be present. 
+For example, P1347Y, P1347M and P1Y2MT2H are all allowed; P0Y1347M
+and P0Y1347M0D are allowed. P-1347M is not allowed although -P1347M
+is allowed. P1Y2MT is not allowed. 
+
+*/
+
+/* this is only an aproximation of duration, more work still to do.
+   see above schema url for more info on duration
+   
+   TODO: figure out best aproximation for year and month conversion to seconds
+*/
+   
+$ereg_duration = '(-)?P([0-9]+Y)?([0-9]+M)?([0-9]+D)?T?([0-9]+H)?([0-9]+M)?([0-9]+S)?';
 class SOAP_Type_duration
 {
     // format PnYnMnDTnHnMnS
-    function unix_to_duration($seconds)
-    {
+    function unix_to_duration($seconds) {
         return SOAP_Type_duration::getduration($seconds);
     }
-
-    function mod($a, $b, &$d, &$r)
-    {
-        $d = floor($a / $b);
+    
+    function mod($a, $b, &$d, &$r) {
+        $d = floor( $a / $b );
         $r = $a % $b;
     }
-
-    function getduration($seconds)
-    {
+    
+    function getduration($seconds) {
         $neg = '';
         if ($seconds < 0) {
@@ -98,5 +73,5 @@
             $seconds = $seconds * -1;
         }
-
+        
         $_mi = 60;
         $_h = $_mi * 60;
@@ -111,5 +86,5 @@
         SOAP_Type_duration::mod($seconds, $_h, $h, $seconds);
         SOAP_Type_duration::mod($seconds, $_mi, $mi, $s);
-
+        
         $duration = $neg.'P';
         if ($y) $duration .= $y.'Y';
@@ -121,10 +96,8 @@
         if ($s) $duration .= $s.'S';
         if ($duration == 'P' || $duration == '-P') $duration = 'PT0S';
-
         return $duration;
     }
-
-    function mkduration($n, $Y, $Mo, $D, $H, $Mi, $S)
-    {
+    
+    function mkduration($n, $Y, $Mo, $D, $H, $Mi, $S) {
         $_mi = 60;
         $_h = $_mi * 60;
@@ -133,26 +106,24 @@
         $_m = $_d * 30;
         $_y = $_d * 365;
-
+        
         $sec = $Y * $_y + $Mo * $_m + $D * $_d + $H * $_h + $Mi * $_mi + $S;
         if ($n == '-') $sec = $sec * -1;
-
         return $sec;
     }
-
-    function duration_to_unix($duration)
-    {
-        if (ereg('(-)?P([0-9]+Y)?([0-9]+M)?([0-9]+D)?T?([0-9]+H)?([0-9]+M)?([0-9]+S)?', $duration, $regs)) {
+    
+    function duration_to_unix($duration) {
+        global $ereg_duration;
+        if (ereg($ereg_duration,$duration,$regs)) {
             return SOAP_Type_duration::mkduration($regs[1], $regs[2], $regs[3], $regs[4], $regs[5], $regs[6], $regs[7]);
         }
-        return false;
+        return FALSE;
     }
-
-    function is_duration($duration)
-    {
-        return ereg('(-)?P([0-9]+Y)?([0-9]+M)?([0-9]+D)?T?([0-9]+H)?([0-9]+M)?([0-9]+S)?', $duration, $regs);
+    
+    function is_duration($duration) {
+        global $ereg_duration;
+        return ereg($ereg_duration,$duration,$regs);
     }
-
-    function _test($time)
-    {
+    
+    function _test($time) {
         if (SOAP_Type_duration::is_duration($time)) {
             $t = SOAP_Type_duration::duration_to_unix($time);
@@ -164,14 +135,12 @@
         return $t;
     }
-
-    function add($d1, $d2)
-    {
+    
+    function add($d1, $d2) {
         $s1 = SOAP_Type_duration::duration_to_unix($d1);
         $s2 = SOAP_Type_duration::duration_to_unix($d2);
         return SOAP_Type_duration::unix_to_duration($s1 + $s2);
     }
-
-    function subtract($d1, $d2)
-    {
+    
+    function subtract($d1, $d2) {
         $s1 = SOAP_Type_duration::duration_to_unix($d1);
         $s2 = SOAP_Type_duration::duration_to_unix($d2);
@@ -181,5 +150,6 @@
 }
 
-/* Tests. */
+/* tests */
+
 $t = SOAP_Type_duration::_test('P1Y2M3DT10H30M');
 SOAP_Type_duration::_test($t);
@@ -187,8 +157,9 @@
 SOAP_Type_duration::_test($t);
 
-/* Duration since 1970. */
+// duration since 1970
 $t = SOAP_Type_duration::_test(time());
 SOAP_Type_duration::_test($t);
 
-echo 'Add should be PT0S: ' . SOAP_Type_duration::add('-P120D','P4M') . "\n";
-echo 'Subtract should be PT0S: ' . SOAP_Type_duration::subtract('P120D','P4M') . "\n";
+print "Add should be PT0S: ".SOAP_Type_duration::add('-P120D','P4M')."\n";
+print "Subtract should be PT0S: ".SOAP_Type_duration::subtract('P120D','P4M')."\n";
+?>
Index: /branches/version-2_11-dev/data/module/SOAP/Type/dateTime.php
===================================================================
--- /branches/version-2_11-dev/data/module/SOAP/Type/dateTime.php	(revision 21318)
+++ /branches/version-2_11-dev/data/module/SOAP/Type/dateTime.php	(revision 21410)
@@ -1,5 +1,5 @@
 <?php
 /**
- * This file contains the code for the SOAP_Type_dateTime class.
+ * This file contains the code for the SOAP date/time clas.
  *
  * PHP versions 4 and 5
@@ -17,5 +17,5 @@
  * @author     Shane Caraveo <Shane@Caraveo.com>   Port to PEAR and more
  * @author     Jan Schneider <jan@horde.org>       Maintenance
- * @copyright  2003-2007 The PHP Group
+ * @copyright  2003-2005 The PHP Group
  * @license    http://www.php.net/license/2_02.txt  PHP License 2.02
  * @link       http://pear.php.net/package/SOAP
@@ -31,5 +31,5 @@
  * @author   Jan Schneider <jan@horde.org>       Maintenance
  */
-class SOAP_Type_dateTime
+class SOAP_Type_dateTime 
 {
     var $_iso8601 =
@@ -97,5 +97,5 @@
         //simulate PHP5's P parameter
         $zone = date('O', $timestamp);
-        if (strlen($zone) === 5) {
+        if (strlen($zone) == 5) {
             $zone = substr($zone, 0, 3) . ':' . substr($zone, 3);
         }
Index: /branches/version-2_11-dev/data/module/SOAP/Parser.php
===================================================================
--- /branches/version-2_11-dev/data/module/SOAP/Parser.php	(revision 21318)
+++ /branches/version-2_11-dev/data/module/SOAP/Parser.php	(revision 21410)
@@ -221,10 +221,12 @@
 
         // Add current node's value.
-        $nqn = new QName($this->message[$pos]['name'],
-                         $this->message[$pos]['namespace']);
-        $tqn = new QName($this->message[$pos]['type'],
-                         $this->message[$pos]['type_namespace']);
         if ($response) {
-            $response = new SOAP_Value($nqn->fqn(), $tqn->fqn(), $response,
+            $nqn = new QName($this->message[$pos]['name'],
+                             $this->message[$pos]['namespace']);
+            $tqn = new QName($this->message[$pos]['type'],
+                             $this->message[$pos]['type_namespace']);
+            $response = new SOAP_Value($nqn->fqn(),
+                                       $tqn->fqn(),
+                                       $response,
                                        $attrs);
             if (isset($this->message[$pos]['arrayType'])) {
@@ -232,13 +234,17 @@
             }
         } else {
+            $nqn = new QName($this->message[$pos]['name'],
+                             $this->message[$pos]['namespace']);
+            $tqn = new QName($this->message[$pos]['type'],
+                             $this->message[$pos]['type_namespace']);
             // Check if value is an empty array
             if ($tqn->name == 'Array') {
-                $response = new SOAP_Value($nqn->fqn(), $tqn->fqn(), array(),
-                                           $attrs);
-                //if ($pos == 4) var_dump($this->message[$pos], $response);
+                $response =& new SOAP_Value($nqn->fqn(), $tqn->fqn(),
+                                            array(), $attrs);
             } else {
-                $response = new SOAP_Value($nqn->fqn(), $tqn->fqn(),
-                                           $this->message[$pos]['cdata'],
-                                           $attrs);
+                $response = new SOAP_Value($nqn->fqn(),
+                                            $tqn->fqn(),
+                                            $this->message[$pos]['cdata'],
+                                            $attrs);
             }
         }
@@ -251,5 +257,4 @@
             $response->mustunderstand = $this->message[$pos]['mustUnderstand'];
         }
-
         return $response;
     }
Index: /branches/version-2_11-dev/data/module/SOAP/Transport.php
===================================================================
--- /branches/version-2_11-dev/data/module/SOAP/Transport.php	(revision 21318)
+++ /branches/version-2_11-dev/data/module/SOAP/Transport.php	(revision 21410)
@@ -116,10 +116,11 @@
     }
 
-    function getTransport($url, $encoding = SOAP_DEFAULT_ENCODING)
+    function &getTransport($url, $encoding = SOAP_DEFAULT_ENCODING)
     {
         $urlparts = @parse_url($url);
 
         if (!$urlparts['scheme']) {
-            return SOAP_Base_Object::_raiseSoapFault("Invalid transport URI: $url");
+            $fault = SOAP_Base_Object::_raiseSoapFault("Invalid transport URI: $url");
+            return $fault;
         }
 
@@ -132,15 +133,18 @@
             $transport_type = strtoupper($urlparts['scheme']);
         }
+        $transport_include = 'SOAP/Transport/' . basename($transport_type) . '.php';
+        $res = @include_once($transport_include);
+        if (!$res) {
+            $fault = SOAP_Base_Object::_raiseSoapFault("No Transport for {$urlparts['scheme']}");
+            return $fault;
+        }
         $transport_class = "SOAP_Transport_$transport_type";
         if (!class_exists($transport_class)) {
-            if (!(@include_once('SOAP/Transport/' . basename($transport_type) . '.php'))) {
-                return SOAP_Base_Object::_raiseSoapFault("No Transport for {$urlparts['scheme']}");
-            }
+            $fault = SOAP_Base_Object::_raiseSoapFault("No Transport class $transport_class");
+            return $fault;
         }
-        if (!class_exists($transport_class)) {
-            return SOAP_Base_Object::_raiseSoapFault("No Transport class $transport_class");
-        }
+        $t =& new $transport_class($url, $encoding);
 
-        return new $transport_class($url, $encoding);
+        return $t;
     }
 
Index: /branches/version-2_11-dev/data/module/SOAP/Value.php
===================================================================
--- /branches/version-2_11-dev/data/module/SOAP/Value.php	(revision 21318)
+++ /branches/version-2_11-dev/data/module/SOAP/Value.php	(revision 21410)
@@ -41,74 +41,37 @@
 {
     /**
-     * The actual value.
-     *
-     * @var mixed
+     * @var string
      */
     var $value = null;
 
     /**
-     * QName instance representing the value name.
-     *
-     * @var QName
-     */
+     * @var string
+     */
+    var $name = '';
+
+    /**
+     * @var string
+     */
+    var $type = '';
+
+    /**
+     * Namespace
+     *
+     * @var string
+     */
+    var $namespace = '';
+    var $type_namespace = '';
+
+    var $attributes = array();
+
+    /**
+     * @var string
+     */
+    var $arrayType = '';
+
+    var $options = array();
+
     var $nqn;
-
-    /**
-     * The value name, without namespace information.
-     *
-     * @var string
-     */
-    var $name = '';
-
-    /**
-     * The namespace of the value name.
-     *
-     * @var string
-     */
-    var $namespace = '';
-
-    /**
-     * QName instance representing the value type.
-     *
-     * @var QName
-     */
     var $tqn;
-
-    /**
-     * The value type, without namespace information.
-     *
-     * @var string
-     */
-    var $type = '';
-
-    /**
-     * The namespace of the value type.
-     *
-     * @var string
-     */
-    var $type_namespace = '';
-
-    /**
-     * The type of the array elements, if this value is an array.
-     *
-     * @var string
-     */
-    var $arrayType = '';
-
-    /**
-     * A hash of additional attributes.
-     *
-     * @see SOAP_Value()
-     * @var array
-     */
-    var $attributes = array();
-
-    /**
-     * List of encoding and serialization options.
-     *
-     * @see SOAP_Value()
-     * @var array
-     */
-    var $options = array();
 
     /**
@@ -119,32 +82,19 @@
      *                           automatically if not set.
      * @param mixed $value       Value to set.
-     * @param array $attributes  A has of additional XML attributes to be
-     *                           added to the serialized value.
-     * @param array $options     A list of encoding and serialization options:
-     *                           - 'attachment': array with information about
-     *                             the attachment
-     *                           - 'soap_encoding': defines encoding for SOAP
-     *                             message part of a MIME encoded SOAP request
-     *                             (default: base64)
-     *                           - 'keep_arrays_flat': use the tag name
-     *                             multiple times for each element when
-     *                             passing in an array in literal mode
-     *                           - 'no_type_prefix': supress adding of the
-     *                             namespace prefix
+     * @param array $attributes  Attributes.
      */
     function SOAP_Value($name = '', $type = false, $value = null,
-                        $attributes = array(), $options = array())
-    {
+                        $attributes = array())
+    {
+        // Detect type if not passed.
         $this->nqn = new QName($name);
         $this->name = $this->nqn->name;
         $this->namespace = $this->nqn->namespace;
-        if ($type) {
-            $this->tqn = new QName($type);
-            $this->type = $this->tqn->name;
-            $this->type_namespace = $this->tqn->namespace;
-        }
+        $this->tqn = new QName($type);
+        $this->type = $this->tqn->name;
+        $this->type_prefix = $this->tqn->ns;
+        $this->type_namespace = $this->tqn->namespace;
         $this->value = $value;
         $this->attributes = $attributes;
-        $this->options = $options;
     }
 
@@ -160,6 +110,8 @@
     {
         return $serializer->_serializeValue($this->value,
-                                            $this->nqn,
-                                            $this->tqn,
+                                            $this->name,
+                                            $this->type,
+                                            $this->namespace,
+                                            $this->type_namespace,
                                             $this->options,
                                             $this->attributes,
@@ -205,9 +157,9 @@
 
         if (isset($actor)) {
-            $this->attributes[SOAP_BASE::SOAPENVPrefix().':actor'] = $actor;
-        } elseif (!isset($this->attributes[SOAP_BASE::SOAPENVPrefix().':actor'])) {
-            $this->attributes[SOAP_BASE::SOAPENVPrefix().':actor'] = 'http://schemas.xmlsoap.org/soap/actor/next';
-        }
-        $this->attributes[SOAP_BASE::SOAPENVPrefix().':mustUnderstand'] = (int)$mustunderstand;
+            $this->attributes['SOAP-ENV:actor'] = $actor;
+        } elseif (!isset($this->attributes['SOAP-ENV:actor'])) {
+            $this->attributes['SOAP-ENV:actor'] = 'http://schemas.xmlsoap.org/soap/actor/next';
+        }
+        $this->attributes['SOAP-ENV:mustUnderstand'] = (int)$mustunderstand;
     }
 
@@ -232,12 +184,11 @@
      *                          is provide.
      * @param string $file      The attachment data.
-     * @param array $attributes Attributes.
      */
     function SOAP_Attachment($name = '', $type = 'application/octet-stream',
-                             $filename, $file = null, $attributes = null)
+                             $filename, $file = null)
     {
         parent::SOAP_Value($name, null, null);
 
-        $filedata = $file === null ? $this->_file2str($filename) : $file;
+        $filedata = ($file === null) ? $this->_file2str($filename) : $file;
         $filename = basename($filename);
         if (PEAR::isError($filedata)) {
@@ -248,6 +199,5 @@
         $cid = md5(uniqid(time()));
 
-        $this->attributes = $attributes;
-        $this->attributes['href'] = 'cid:' . $cid;
+        $this->attributes['href'] = 'cid:' . $cid; 
 
         $this->options['attachment'] = array('body' => $filedata,
